var WOLK

if( typeof window === 'undefined' ) {
  WOLK = require("./index.js").FS;
} else {
  WOLK = require("./index.js").WOLK;
}

const cloudstore = new WOLK();

var wolkurl = process.argv[2]
var wolkUrlObject = parseWolkUrl(wolkurl)
console.log("Resolving: " + wolkurl)

cloudstore.loadDefaultAccount()
.then( () => {
  if ( cloudstore.ecdsaKey == undefined ) {
    var wolkName = "user" + Math.floor((Math.random() * 1000) + 1);
    console.log("no user found -- creating one: " + wolkName)
    cloudstore.createAccount(wolkName)
    .then( () => {
        cloudstore.getKey(wolkUrlObject.owner, wolkUrlObject.collection, wolkUrlObject.path)
        .then( (gkres) => {
          console.log("Result: \n\n" + gkres)
        })
    })
  } else {
    cloudstore.getKey(wolkUrlObject.owner, wolkUrlObject.collection, wolkUrlObject.path)
    .then( (gkres) => {
      console.log("Result: \n\n" + gkres)
    })
  }
})
.catch(err => {
  console.error("ERROR: " + err)
})

function parseWolkUrl(wolkurl) {
  let urlParts = wolkurl.split("/");
  let wolkProtocolString = "wolk:"
  var protocol = ""
  var owner = ""
  var collection = ""
  var key = ""
  var wolkUrlObject = {
    protocol: "",
    owner: "",
    collection: "",
    path: "",
    urltype: "",
    query: ""
  };
  /* wolk://owner/collection/key */

  if (urlParts.length > 0) {
    wolkUrlObject.protocol = urlParts[0];
    if (wolkUrlObject.protocol != wolkProtocolString) {
      throw new Error("Invalid Wolk URL: " + url)
    }
  }

  if (wolkUrlObject.protocol != "wolk:") {
    console.log('ERROR: calling parseWolkUrl on a non-Wolk URL: ' + wolkurl)
  }

  if (urlParts.length > 2) {
    if (urlParts[2].length > 0) {
      wolkUrlObject.owner = urlParts[2];
    } else {
      //throw new Error("Invalid Wolk URL: " + wolkurl + "owner length must be > 0")
      //though we could just show wolk://
    }
  }

  if (urlParts.length > 3) {
    wolkUrlObject.collection = urlParts[3];
  }

  if (urlParts.length > 4) {
    wolkUrlObject.path = wolkurl.substring(wolkUrlObject.protocol.length + wolkUrlObject.owner.length + wolkUrlObject.collection.length + 4);
    wolkUrlObject.urltype = "key"
  }
  //TODO: Query String support -- wolkUrlObject.query = url.query
  return wolkUrlObject;
}
