const extensionID = "mfjilaelpjckpokkihghmiffcmjalofh";

module.exports = {
    accountCheck: function(callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "accountCheck", param: {}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "accountCheck", param: {}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });
        }
    },    

    getOwner: function(callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "getOwner", param: {}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "getOwner", param: {}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }
    },

    getLatestBlockNumber: function(callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "getLatestBlockNumber", param: {}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "getLatestBlockNumber", param: {}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "getLatestBlockNumber", param: {}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    getTransaction: function(txhash, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "getTransaction", param: {txhash: txhash}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "getTransaction", param: {txhash: txhash}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }
    },

    getBlock: function(blockNumber, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "getBlock", param: {blockNumber: blockNumber}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "getBlock", param: {blockNumber: blockNumber}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "getBlock", param: {blockNumber: blockNumber}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    getName: function(name, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "getName", param: {name: name}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "getName", param: {name: name}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "getName", param: {name: name}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    // TO-DO: does setProvider need callback or promise?
    setProvider: function(provider, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "setProvider", param: {provider: provider}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "setProvider", param: {provider: provider}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "setProvider", param: {provider: provider}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },    

    /* should not expose createAccount in extension case, since account is only created inside the extension popup
    createAccount: function(name, callback) {
        window.chrome.runtime.sendMessage(extensionID, { method: "createAccount", param: {name: name}}, function(response) {
            console.log(response.err, response.result);
            callback(response.err, response.result);
        });
    },
    */

    listCollections: function(owner, hdrs, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "listCollections", param: {hdrs: JSON.stringify(hdrs)}}, function(response) {
                console.log(response.err, response.result, response.proof, response.verified);
                return callback(response.err, response.result, response.proof, response.verified);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "listCollections", param: {hdrs: JSON.stringify(hdrs)}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result, response.proof, response.verified);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "listCollections", param: {}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    createBucket: function(owner, collection, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "createBucket", param: {collection: collection}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "createBucket", param: {collection: collection}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }
    },    

	createCollection: function(owner, collection, hdrs, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "createCollection", param: {collection: collection, hdrs: JSON.stringify(hdrs)}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "createCollection", param: {collection: collection, hdrs: JSON.stringify(hdrs)}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "createCollection", param: {collection: collection}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    deleteCollection: function(owner, collection, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "deleteCollection", param: {collection: collection}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "deleteCollection", param: {collection: collection}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "deleteCollection", param: {collection: collection}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    scanCollection: function(owner, collection, hdrs, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "scanCollection", param: {collection: collection, hdrs: JSON.stringify(hdrs)}}, function(response) {
                console.log(response.err, response.result, response.proof, response.verified);
                return callback(response.err, response.result, response.proof, response.verified);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "scanCollection", param: {collection: collection, hdrs: JSON.stringify(hdrs)}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result, response.proof, response.verified);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "scanCollection", param: {collection: collection}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

	setKey: function(owner, collection, key, value, hdrs, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "setKey", param: {collection: collection, key: key, value: value, hdrs: JSON.stringify(hdrs)}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "setKey", param: {collection: collection, key: key, value: value, hdrs: JSON.stringify(hdrs)}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "setKey", param: {collection: collection, key: key, value: value}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

	getKey: function(owner, collection, key, hdrs, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "getKey", param: {collection: collection, key: key, hdrs: JSON.stringify(hdrs)}}, function(response) {
                console.log(response.err, response.result, response.proof, response.verified);
                return callback(response.err, response.result, response.proof, response.verified);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "getKey", param: {collection: collection, key: key, hdrs: JSON.stringify(hdrs)}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result, response.proof, response.verified);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "getKey", param: {collection: collection, key: key}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    deleteKey: function(owner, collection, key, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "deleteKey", param: {collection: collection, key: key}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "deleteKey", param: {collection: collection, key: key}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "deleteKey", param: {collection: collection, key: key}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    transfer: function(recipient, amount, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "transfer", param: {recipient: recipient, amount: amount}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "transfer", param: {recipient: recipient, amount: amount}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "transfer", param: {recipient: recipient, amount: amount}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    getAccount: function(name, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "getAccount", param: {name: name}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "getAccount", param: {name: name}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "getAccount", param: {name: name}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    getNode: function(nodeNumber, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "getNode", param: {nodeNumber: nodeNumber}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "getNode", param: {nodeNumber: nodeNumber}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }

        // window.chrome.runtime.sendMessage(extensionID, { method: "getNode", param: {nodeNumber: nodeNumber}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    updateNode: function(nodeNumber, nodeInfo, callback) {
        if (callback) {
            window.chrome.runtime.sendMessage(extensionID, { method: "updateNode", param: {nodeNumber: nodeNumber, nodeInfo: nodeInfo}}, function(response) {
                console.log(response.err, response.result);
                return callback(response.err, response.result);
            });
        }
        else {
            return new Promise((resolve, reject) => {
                window.chrome.runtime.sendMessage(extensionID, { method: "updateNode", param: {nodeNumber: nodeNumber, nodeInfo: nodeInfo}}, function(response) {
                    console.log(response.err, response.result);
                    if (response.err) {
                        reject(response.err);
                    }
                    else {
                        resolve(response.result);
                    }
                });
            });         
        }
               
        // window.chrome.runtime.sendMessage(extensionID, { method: "updateNode", param: {nodeNumber: nodeNumber, nodeInfo: nodeInfo}}, function(response) {
        //     console.log(response.err, response.result);
        //     callback(response.err, response.result);
        // });
    },

    waitForTx: function(txhash, callback) {
        window.chrome.runtime.sendMessage(extensionID, { method: "waitForTx", param: {txhash: txhash}}, function(response) {
            console.log(response.err, response.result);
            callback(response.err, response.result);
        });
    },

    isNotFound: function(err) {
        return( err.includes("404") ||  err.includes("500") || err.includes("Not Found") );
    }
};
