class WolkError extends Error {
  //throw new WolkError('400','KeyNotFound')
  constructor(statusCode='200', ...params) {
    // Pass remaining arguments (including vendor specific ones) to parent constructor
    super(...params);

    // Maintains proper stack trace for where our error was thrown (only available on V8)
    if (Error.captureStackTrace) {
      Error.captureStackTrace(this, WolkError);
    }

    this.statusCode = statusCode;
    // Custom debugging information
    this.date = new Date();
  }
}

module.exports = WolkError;
/*
try {
  throw new WolkError(404, 'Key Not Found');
} catch(e){
  console.log(e.statusCode); 404
  console.log(e.date); //date()
  console.log(e.message); //Key Not Found
  console.log(e.stack); //stacktrace
}
*/
