# Wolk JS Class

The Wolk class interface must be identical across Wolk Clients loading a Cloudstore page:
 * Wolk browser
 * Wolk Chrome extension
 * wolk.js script include
This is a test harness for WOLK Class implementations that interact with the Wolk Blockchain:
* Test buttons run through a battery of tests and outputs to console.log the end result.
* Individual calls can be done

Key dimensions tested:
1. Full set of transactions (account, blockchain, nosql, sql) with Wolk GET/POST/DELETE
2. response.ok = true vs false
3. Promise vs Callback  via `test_all_promise` and `test_callback`
4. honest provider (c0) and dishonest provider (c6) where response.ok=true but proofs do not match content

## Model:

* a Cloudstore page expects WOLK class to be available, loaded with with account keys (ecdsaKey, rsaKey, ...) that are used for signing payloads (NoSQL/SQL)

* Developers write applications stored in Cloudstore at a bucket (e.g. wolk://sourabh/myspace)
