var assert = chai.assert;

function randomString(n) {
  return Math.random().toString(36).replace(/[^a-z]+/g, '').substr(0, 5);
}

let TEST_MAX_MS = 20000;
let OWNER = "account" + randomString(5);
let COLLECTION = "collection" + randomString(5);

let HONEST = "c0"
let MALICIOUS = "c1"
let PORT = 443
let HONEST_PROVIDER = "https://" + HONEST + ".wolk.com:" + PORT
let MALICIOUS_PROVIDER = "https://" + MALICIOUS + ".wolk.com:" + PORT

describe('Standalone Proofs', function() {
  it('verifyRangeProof', function(done) {
    let proofObject = {
	"lp": [{
		"h": 3,
		"s": 5,
		"vr": 1,
		"sb": 32,
		"sbt": 221,
		"k": "6B86B273FF34FCE19D6B804EFF5A3F5747ADA4EAA22F1D49C01E52DDB7875B4B",
		"l": "",
		"r": "4B1D10FC87E15A577C0E590BD05BD60B2272A3A442A6AAC8A633D98FB9D79918"
	}, {
		"h": 2,
		"s": 3,
		"vr": 1,
		"sb": 32,
		"sbt": 121,
		"k": "5FECEB66FFC86F38D952786C6D696C79C2DBC239DD4E91B46729D73A27FB57E9",
		"l": "",
		"r": "31E5BC8928BFD6C580D6F2802CFD93073EFB58202BA1FE9F54B810607951AF46"
	}, {
		"h": 1,
		"s": 2,
		"vr": 1,
		"sb": 32,
		"sbt": 66,
		"k": "4E07408562BEDB8B60CE05C1DECFE3AD16B72230967DE01F640B7E4729B49FCE",
		"l": "1340186F93B2A96D5F4D6409054C51945F4757BF023943C5B65A1D58E8BFA7DA",
		"r": ""
	}],
	"in": null,
	"lfs": [{
		"h": 0,
		"s": 1,
		"vr": 1,
		"sb": 22,
		"sbt": 22,
		"k": "4E07408562BEDB8B60CE05C1DECFE3AD16B72230967DE01F640B7E4729B49FCE",
		"v": "33"
	}]
}
    verifyRangeProof(proofObject, 1).then(
      function(verified) {
        assert(verified);
        done();
      }
    )
  });

});
