//import quic from 'node-quic'
const quic = require('node-quic')

const localport    = 1235
const port    = 443
const localaddress = '127.0.0.1'
const address = 'c0.wolk.com'

// First we listen.
/*
quic.listen(localport, localaddress)
  .onData((data, stream, buffer) => {
    console.log("listening?")
    const parsedData = JSON.parse(data)

    console.log("on server listening")
    console.log(parsedData) // { hello: 'world!' }

    // Once the data is received and logged, we'll send it right back
    stream.write(parsedData)
  })
  .then(() => { console.log("started listening")})
*/

// Now we send the data to the server.
quic.send(localport, localaddress, { hello: 'world! from duo' })
  .onData(data => {
    console.log("client response")
    // This is the data that was sent right back
    const parsedData = JSON.parse(data)
    console.log(parsedData) // { hello: 'world!' }

    // now we can stop the server from listening if we want this to be a one-off
    quic.stopListening()
  })
  .then(() => { console.log("stream has been written to: " + localaddress + " : " + localport)})
  .onError((error) => { console.error("ERROR: " + error)})
