var assert = chai.assert;

var TEST_MAX_MS = 20000;

let F1 = "account" + randomString(5);
let F2 = "account" + randomString(5)
let users = [F1, F2];
let client1 = '';
let client2 = '';

describe('Friendship', function() {
  this.timeout(TEST_MAX_MS);
  var txhash1 = '';
  var txhash2 = '';
  it('WolkUser(' + F1 + ')', function(done) {
    client1 = new WolkUser(F1, function (err, result) {
      if (err) {
        throw err;
      }
      txhash1 = result;
    });
    client2 = new WolkUser(F2, function (err, result) {
      if (err) {
        throw err;
      }
      txhash2 = result;
    });
  });

  it('WolkUser(' + F1 + ') waiting', function(done) {
      client1.waitForTx(txhash1, function(err, tx) {
          console.log("===> setName TX: ", txhash, tx)
          let CollectionList = [ ProfilesCollection, FriendsCollection, PostsCollection, MailCollection, DeveloperCollection, AppCollection ];
          CollectionList.map( collection => {
            console.log(collection);
            // TODO: createCollection after createAccount is done!
          })
          done();
        })
      })

  // F1 sends F2 friend request by sending F1's friendsKey using F2's public Key
  /*
  it('f1.befriend(' + F2 + ')', function(done) {
    let request = {
      "@context": "http://schema.org",
      "@type": "BefriendAction",
      "agent": {
        "@type": "Person",
        "name": F1
      },
      "object": {
        "@type": "Person",
        "name": F2
      },
      "friendsKey": {
        "@type": "RSAMessage",
        "key": RSAEncrypt(client1.getRSAPublicKey(F2), client1.getFriendsKey())
      }
    }

    client1.befriend(request, function(err, txhash) {
      client1.waitForTx(txhash, function(err, tx) {
        if (err) {
          throw err;
        }
        console.log("===> befriend TX: ", txhash, tx)
        done();
      })
    });
  });
  */
  /*
  // F2 can see others befriendAction, and can acceptBefriend
  it('f2.befriend(' + F1 + ')', function(done) {
    client2.getFriendRequests(function(err, friendRequests) {
      console.log("===> friend requests: ", friendRequests);
      friendRequests.map(friendRequest => {
        let request = {
          "@context": "http://schema.org",
          "@type": "BefriendAction",
          "agent": {
            "@type": "Person",
            "name": friendRequest.object.name
          },
          "object": {
            "@type": "Person",
            "name": friendRequest.agent.name
          },
          "friendsKey": {
            "@type": "RSAMessage",
            "key": RSAEncrypt(getRSAPublicKey(friendRequest.agent.name), client2.getFriendsKey())
          }
        }
        // this updates the local attribute
        client2.acceptBefriend(request, function(err, txhash) {
          client2.waitForTx(txhash, function(err, tx) {
            client2.befriend(request, function(err, txhash) {
              client2.waitForTx(txhash, function(err, tx) {
                if (err) {
                  throw err;
                }
                console.log("===> befriend TX: ", txhash, tx)
                done();
              })
            });
          })
        })
      })
    });
  });

  // F1 can see others befriendAction, and can acceptBefriend
  // same as above

  it('f2.getFriends()', function(done) {
    client2.getFriends(function(err, friends) {
      console.log("===> friends: ", friends);
      friends.map(friend => {
        // using the friends name and the friends key, can get the full profile
        client2.getProfile(friend, function(err, profile) {
          console.log("===> friend profile: ", profile)
        })
      })
    });
  });

  // friends are allowed to postMessages
  it('f2.postMessage()', function(done) {
    var post = {
      "@context": "http://schema.org",
      "@type": "SocialMediaPosting",
      "author": {
        "@type": "Person",
        "name": F1,
        "url": "wolk://" + F1
      },
      "text": "@F2!  Everything is awesome!"
    }
    client2.postMessage(post, function(err, txhash) {
      console.log("===> friends: ", friends);
    });
  });


});

describe('App Installations', function() {
  this.timeout(15000);

  it('installApp', function(done) {
    var installAction = {
      "@context": "http://schema.org",
      "@type": "InstallAction",
      "agent": {
        "@type": "Person",
        "name": F1
      },
      "object": {
        "@type": "WebApplication",
        "name": "Myspace",
        "permissions": "friends",
        "url": "wolk://publisher/myspace"
      }
    };
    client1.installApp(installAction, function(err, txhash) {
      assert(txhash.length >= 64);
      wolkjs.waitForTx(txhash, function(err, tx) {
        if (err) {
          throw err;
        }
        console.log("===> installApp TX: ", txhash, tx)
        done();
      });
    })
  });

  it('getApps()', function(done) {
    client1.listApps(function(err, apps) {
      console.log("===> apps: ", apps);
      apps.map(app => {
        client1.getApp(app, function(err, appinfo) {
          console.log("===> app info: ", appinfo)
        })
      })
    })
  });

  it('uninstallApp()', function(done) {
    client1.uninstallApp("Myspace", function(err, txhash) {
      assert(txhash.length >= 64);
      wolkjs.waitForTx(txhash, function(err, tx) {
        if (err) {
          throw err;
        }
        console.log("===> installApp TX: ", txhash, tx)
        done();
      });
    })
  });

});

describe('Publish Apps', function() {
  this.timeout(TEST_MAX_MS);
  let publishAction = {
    "@context": "http://schema.org",
    "@type": "CreateAction",
    "agent": {
      "@type": "Person",
      "name": F1
    },
    "result": {
      "@type": "WebApplication",
      "name": "Myspace",
      "url": "wolk://f1/myspace"
    }
  };

  it('publishApp()', function(done) {
    client1.publishApp(publishAction, function(err, txhash) {
      assert(txhash.length >= 64);
      wolkjs.waitForTx(txhash, function(err, tx) {
        if (err) {
          throw err;
        }
        console.log("===> Create Table TX: ", txhash, tx)
        done();
      });
    })
  });

  it('listPublishedApps()', function(done) {
    client1.listPublishedApps(function(err, apps) {
      done();
    })
  });
  */
});
